#include "StdAfx.h"
#include "SchedulerCtrl.h"


TCHAR* g_parrDays[] = { _T("Mon"), _T("Tue"), _T("Wed"), _T("Thu"), _T("Fri"), _T("Sat"), _T("Sun") };


CSchedulerCtrl::CSchedulerCtrl(void)
{
	m_refColor = RGB(0, 128, 0);
	m_refColorHover = RGB(0, 90, 0);
	m_refColorSel = RGB(180, 180, 180);
	m_refColorBorder = RGB(0, 0, 0);

	m_pHoveredHour = NULL;

	m_hFontDays = CreateFont(
						13,                        // nHeight
						0,                         // nWidth
						0,                         // nEscapement
						0,                         // nOrientation
						FW_BOLD,                 // nWeight
						FALSE,                     // bItalic
						FALSE,                     // bUnderline
						0,                         // cStrikeOut
						ANSI_CHARSET,              // nCharSet
						OUT_DEFAULT_PRECIS,        // nOutPrecision
						CLIP_DEFAULT_PRECIS,       // nClipPrecision
						DEFAULT_QUALITY,           // nQuality
						DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
						_T("Tahoma"));            // lpszFacename

	m_hFontSelHour = CreateFont(
						13,                        // nHeight
						0,                         // nWidth
						0,                         // nEscapement
						0,                         // nOrientation
						FW_NORMAL,                 // nWeight
						FALSE,                     // bItalic
						FALSE,                     // bUnderline
						0,                         // cStrikeOut
						ANSI_CHARSET,              // nCharSet
						OUT_DEFAULT_PRECIS,        // nOutPrecision
						CLIP_DEFAULT_PRECIS,       // nClipPrecision
						DEFAULT_QUALITY,           // nQuality
						DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
						_T("Tahoma"));            // lpszFacename

	m_hBrushBk = CreateSolidBrush(GetSysColor(COLOR_BTNFACE));

}

CSchedulerCtrl::~CSchedulerCtrl(void)
{
	DeleteObject(m_hFontDays);
	DeleteObject(m_hFontSelHour);
	DeleteObject(m_hBrushBk);
}

bool CSchedulerCtrl::Init(int nX, int nY, int nCellWidth, int nCellHeight)
{
	m_nCellWidth	= nCellWidth;
	m_nCellHeight	= nCellHeight;
	

	///////////////////////////////////////////////////

	m_rc.left	= nX;
	m_rc.top	= nY;
	m_rc.right	= m_rc.left + (nCellWidth * 24);
	m_rc.bottom	= m_rc.top + (nCellHeight * 7);


	////////////////////////////////////////////////////

	SHour myHour;

	for (int i = 0; i < 7; ++i) //days
	{
		myHour.cDay = i;
		for (int j = 0; j < 24; ++j) //hours
		{
			myHour.cHour	= j;
			myHour.cState	= SHour::STATE_FREE;
			myHour.nX		= (j * nCellWidth) + nX;
			myHour.nY		= (i * nCellHeight) + nY;

			m_vecHours.push_back(myHour);
		}
	}


	return true;
}

void CSchedulerCtrl::PaintCell(HDC hDC, SHour& myHour)
{
	MoveToEx(hDC, myHour.nX + m_nCellWidth, myHour.nY + m_nCellHeight, NULL);
	LineTo(hDC, myHour.nX + m_nCellWidth, myHour.nY);
	
	MoveToEx(hDC, myHour.nX + m_nCellWidth, myHour.nY + m_nCellHeight, NULL);
	LineTo(hDC, myHour.nX, myHour.nY + m_nCellHeight);


	////////////////////////////////////////////////

	RECT rc;

	rc.left		= myHour.nX + 1;
	rc.top		= myHour.nY + 1;
	rc.right	= rc.left + m_nCellWidth - 1;
	rc.bottom	= rc.top + m_nCellHeight - 1;


	HBRUSH hBrush = NULL;
	
	if (myHour.cState == SHour::STATE_FREE)
		hBrush = CreateSolidBrush(m_refColor);
	else if (myHour.cState == SHour::STATE_HOVERED)
		hBrush = CreateSolidBrush(m_refColorHover);
	else if (myHour.cState == SHour::STATE_SELECTED)
		hBrush = CreateSolidBrush(m_refColorSel);

	FillRect(hDC, &rc, hBrush);
	DeleteObject(hBrush);


}

void CSchedulerCtrl::Paint(HDC hDC)
{
	HPEN hPen = CreatePen(PS_SOLID, 1, m_refColorBorder);
	HPEN hPenOld = (HPEN)SelectObject(hDC, hPen);


	MoveToEx(hDC, m_rc.left, m_rc.top, NULL);
	LineTo(hDC, m_rc.right + 1, m_rc.top);

	MoveToEx(hDC, m_rc.left, m_rc.top + 1, NULL);
	LineTo(hDC, m_rc.left, m_rc.bottom + 1);


	unsigned uiCount = m_vecHours.size();
	for (unsigned i = 0; i < uiCount; ++i)
	{
		PaintCell(hDC, m_vecHours.at(i));
	}

	SelectObject(hDC, hPenOld);
	DeleteObject(hPen);



	SetBkMode(hDC, TRANSPARENT);
	SelectObject(hDC, m_hFontDays);

	RECT rc;

	TCHAR* parrDays[] = { _T("Mon"), _T("Tue"), _T("Wed"), _T("Thu"), _T("Fri"), _T("Sat"), _T("Sun") };
	for (int i = 0; i < 7; ++i)
	{
		rc.left		= m_rc.left - (m_nCellWidth * 2); //margin
		rc.right	= rc.left + m_nCellWidth * 2;
		rc.top		= m_rc.top + (m_nCellHeight * i);
		rc.bottom	= rc.top + m_nCellHeight;

		DrawText(hDC, parrDays[i], _tcslen(parrDays[i]), &rc, DT_CENTER);
	}

	TCHAR* pBuff = new TCHAR[MAX_PATH];
	for (int i = 0; i < 24; ++i)
	{
		rc.left		= m_rc.left + (i * m_nCellWidth);
		rc.right	= rc.left + m_nCellWidth;
		rc.top		= m_rc.top - m_nCellHeight;
		rc.bottom	= m_rc.top + m_nCellHeight;

		_sntprintf(pBuff, MAX_PATH - 1, _T("%2d"), i);

		DrawText(hDC, pBuff, _tcslen(pBuff), &rc, DT_CENTER);

	}
	delete[] pBuff;
}

void CSchedulerCtrl::OnMouseLClick(HDC hDC, int nX, int nY, RECT *prcChanged)
{
	POINT pt;
	
	pt.x = nX;
	pt.y = nY;

	if (!PtInRect(&m_rc, pt))
		return;

	int nHour = (nX - m_rc.left) / m_nCellWidth;		//row
	nHour += ((nY - m_rc.top) / m_nCellHeight) * 24;	//column

	if (nHour > (int)m_vecHours.size())
		return;

	m_pHoveredHour = &m_vecHours.at(nHour);
	if (m_pHoveredHour->cState == SHour::STATE_SELECTED)
		m_pHoveredHour->cState = SHour::STATE_FREE;
	else
		m_pHoveredHour->cState = SHour::STATE_SELECTED;

	PaintCell(hDC, *m_pHoveredHour);

	prcChanged->left	= m_pHoveredHour->nX;
	prcChanged->top		= m_pHoveredHour->nY;
	prcChanged->right	= m_pHoveredHour->nX + m_nCellWidth;
	prcChanged->bottom	= m_pHoveredHour->nY + m_nCellHeight;

}

void CSchedulerCtrl::PaintHourTime(HDC hDC, int nX, SHour* pHour)
{
	TCHAR* pBuff = new TCHAR[MAX_PATH];

	_stprintf(pBuff, _T("%s %02d:00 - %02d:59"), g_parrDays[pHour->cDay], pHour->cHour, pHour->cHour);

	RECT rc;
	rc.left		= m_rc.left;
	rc.top		= m_rc.bottom + 10;
	rc.right	= 200;
	rc.bottom	= rc.top + m_nCellHeight;

	SelectObject(hDC, m_hFontSelHour);
	SetBkMode(hDC, TRANSPARENT);
	
	FillRect(hDC, &rc, m_hBrushBk);
	DrawText(hDC, pBuff, _tcslen(pBuff), &rc, DT_CENTER);

	delete[] pBuff;
}

void CSchedulerCtrl::OnMouseMove(HDC hDC, int nX, int nY, RECT* prcChanged, RECT* prcChanged2)
{
	POINT pt;
	
	pt.x = nX;
	pt.y = nY;

	if (!PtInRect(&m_rc, pt))
	{
		if (m_pHoveredHour && m_pHoveredHour->cState != SHour::STATE_SELECTED)
		{
			m_pHoveredHour->cState = SHour::STATE_FREE;
			PaintCell(hDC, *m_pHoveredHour);

			prcChanged->left	= m_pHoveredHour->nX;
			prcChanged->top		= m_pHoveredHour->nY;
			prcChanged->right	= m_pHoveredHour->nX + m_nCellWidth;
			prcChanged->bottom	= m_pHoveredHour->nY + m_nCellHeight;
		}

		return;
	}

	int nHour = (nX - m_rc.left) / m_nCellWidth;		//row
	nHour += ((nY - m_rc.top) / m_nCellHeight) * 24;	//column

	if (nHour > (int)m_vecHours.size())
		return;

	if (m_pHoveredHour && m_pHoveredHour->cState != SHour::STATE_SELECTED)
	{
		m_pHoveredHour->cState = SHour::STATE_FREE;
		PaintCell(hDC, *m_pHoveredHour);

		prcChanged->left	= m_pHoveredHour->nX;
		prcChanged->top		= m_pHoveredHour->nY;
		prcChanged->right	= m_pHoveredHour->nX + m_nCellWidth;
		prcChanged->bottom	= m_pHoveredHour->nY + m_nCellHeight;
	}

	m_pHoveredHour = &m_vecHours.at(nHour);
	if (m_pHoveredHour && m_pHoveredHour->cState == SHour::STATE_SELECTED)
	{
		PaintHourTime(hDC, nX, m_pHoveredHour);

		m_pHoveredHour = NULL;
		return;
	}

	m_pHoveredHour->cState = SHour::STATE_HOVERED;
	PaintCell(hDC, *m_pHoveredHour);

	prcChanged2->left	= m_pHoveredHour->nX;
	prcChanged2->top	= m_pHoveredHour->nY;
	prcChanged2->right	= m_pHoveredHour->nX + m_nCellWidth;
	prcChanged2->bottom	= m_pHoveredHour->nY + m_nCellHeight;


	if (m_pHoveredHour)
		PaintHourTime(hDC, nX, m_pHoveredHour);
	
}

void CSchedulerCtrl::SetColor(COLORREF& refClr)
{
	m_refColor = refClr;
}

void CSchedulerCtrl::SetColorHover(COLORREF& refClr)
{
	m_refColorHover = refClr;
}

void CSchedulerCtrl::SetColorSel(COLORREF& refClr)
{
	m_refColorSel = refClr;
}

void CSchedulerCtrl::SetColorBorder(COLORREF& refClr)
{
	m_refColorBorder = refClr;
}

void CSchedulerCtrl::SetCellDimensions(int nCX, int nCY)
{
	m_nCellWidth	= nCX;
	m_nCellHeight	= nCY;
}

void CSchedulerCtrl::GetSelectedHours(VECSELHOURS& vecSelHours)
{
	unsigned uiCount = m_vecHours.size();
	for (unsigned int i = 0; i < uiCount; ++i)
	{
		if (m_vecHours.at(i).cState == SHour::STATE_SELECTED)
			vecSelHours.push_back(std::make_pair(m_vecHours.at(i).cDay, m_vecHours.at(i).cHour));
	}
}
